package ctxreader

import (
	"context"
	"io"
)

type ContextReader struct {
	ctx context.Context
	r   io.ReadCloser
}

func (cr *ContextReader) Read(p []byte) (n int, err error) {
	if err := cr.ctx.Err(); err != nil {
		return 0, err
	}
	return cr.r.Read(p)
}

func (cr *ContextReader) Close() error {
	return cr.r.Close()
}

func NewContextReader(ctx context.Context, r io.ReadCloser) io.ReadCloser {
	return &ContextReader{
		ctx: ctx,
		r:   r,
	}
}
